def tesserver():
    from tes import app
    app.config['ENABLELAUNCH'] = True
    from flask_cors import CORS, cross_origin
    CORS(app, supports_credentials=True, origin="*")
    print("try to run tesserver")
    app.run(host='localhost',debug=False,port=8080)
    print('app is running')

def tws():
    from twsproxy import server
    import sys
    import os
    import logging
    port = 8090
    logger=logging.getLogger()
    if port is None:
        try:
            port = int(sys.argv[1])
        except:
            port = 8090
    server = server.TWSServer(port,5)
    logger.debug("initialised server object")
    server.run()


def main():
    import logging
    logging.basicConfig(filename="tes.log",format="%(asctime)s %(levelname)s:%(process)s: %(message)s")
    logger=logging.getLogger()
    logger.setLevel(logging.DEBUG)
    import threading
    print("create thread")
    twsthread = threading.Thread(target=tws)
    twsthread.start()
    print("thread started")
    tesserver()
    twsthread.join()

    
if __name__ == "__main__":
    main()
